import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
import cx from 'classnames';
import SpinnerBasic from '@s-ui/react-spinner-basic';
import { useNearScreen } from '@s-ui/react-hooks';
var BASE_CLASS = 'sui-ImageLazyLoad';
/**
 * Component that will print defer loading images with an optional and specific
 * aspect ratio.
 */

export default function ImageLazyLoad(_ref) {
  var _cx;

  var _ref$alt = _ref.alt,
      alt = _ref$alt === void 0 ? '' : _ref$alt,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? '' : _ref$title,
      _ref$aspectRatio = _ref.aspectRatio,
      aspectRatio = _ref$aspectRatio === void 0 ? '' : _ref$aspectRatio,
      _ref$offsetVertical = _ref.offsetVertical,
      offsetVertical = _ref$offsetVertical === void 0 ? 100 : _ref$offsetVertical,
      _ref$showSpinner = _ref.showSpinner,
      showSpinner = _ref$showSpinner === void 0 ? true : _ref$showSpinner,
      src = _ref.src;

  var _useNearScreen = useNearScreen({
    offset: offsetVertical + "px"
  }),
      isNearScreen = _useNearScreen[0],
      fromRef = _useNearScreen[1];

  var lazyLoadWrapClassName = cx(BASE_CLASS, (_cx = {}, _cx[BASE_CLASS + "--ratio-" + aspectRatio.replace(':', '-')] = aspectRatio, _cx));
  return /*#__PURE__*/_jsxs("div", {
    className: lazyLoadWrapClassName,
    ref: fromRef,
    children: [!isNearScreen && showSpinner && /*#__PURE__*/_jsx("div", {
      className: BASE_CLASS + "-spinner",
      children: /*#__PURE__*/_jsx(SpinnerBasic, {})
    }), /*#__PURE__*/_jsx("div", {
      className: BASE_CLASS + "-imageWrap",
      children: isNearScreen && /*#__PURE__*/_jsx("img", {
        className: BASE_CLASS + "-image",
        src: src,
        alt: alt,
        title: title
      })
    })]
  });
}
ImageLazyLoad.displayName = 'ImageLazyLoad';